public class Parser {
  // Umwandlung Infix in Postfix-Ausdruck
  // mit anschlieender Auswertung

  static int prioritt (char operator) {
    if (operator == '+') return 1;
    if (operator == '*') return 2;
    return 0;
    } // Ende prioritt

  static String Postfix (String infix) {
    // wandelt Infix- in Postfix-Ausdruck um
    Zeichenstapel stapel = new Zeichenstapel(20);
    String postfix = "";
    for (int i = 0; i < infix.length(); i++) {
      char zeichen = infix.charAt(i);
      if (Character.isDigit(zeichen))
        postfix += zeichen;
      else if (zeichen == '(')
        stapel.legeAuf(zeichen);
      else if (zeichen == ')') {
        while (stapel.liesSpitze() != '(')
          postfix += stapel.holeVon();
        stapel.holeVon(); // ffnende Klammer "entsorgen"
        } // Ende else
      else {
        while (! stapel.istLeer() &&
               stapel.liesSpitze() != '(' &&
               prioritt(zeichen) <=
               prioritt(stapel.liesSpitze()))
          postfix += stapel.holeVon();
        stapel.legeAuf(zeichen);
        } // Ende else
      } // Ende for
    while (! stapel.istLeer())
      postfix += stapel.holeVon();
    return postfix;
    } // Ende Postfix

  static int Wert (String postfix) {
    // Berechnet Wert eines Postfix-Ausdrucks
    Zahlstapel stapel = new Zahlstapel(20);
    for (int i = 0; i < postfix.length(); i++) {
      char zeichen = postfix.charAt(i);
      if (Character.isDigit(zeichen))
        stapel.legeAuf(zeichen - '0');
      else { // Zeichen ist keine Ziffer
        int operand1 = stapel.holeVon();
        int operand2 = stapel.holeVon();
        if (zeichen == '+')
          stapel.legeAuf(operand1 + operand2);
        else if (zeichen == '*')
          stapel.legeAuf(operand1 * operand2);
        } // Ende else
      } // Ende for
    int wert = stapel.holeVon();
    if (stapel.istLeer())
      return wert;
    else
      return -1;
    } // Ende Wert

  public static void main (String[] eingabe) {
    String eingabewort = "(2+3)*4";
    if (eingabe.length > 0)
      eingabewort = eingabe[0];
    String wort = Postfix(eingabewort);
    int zahl = Wert(wort);
    System.out.println("\n " + wort + ", " + zahl);
    } // Ende main

  } // Ende Parser

class Zeichenstapel {
  // Implementation mittels Reihung

  int    maxLnge;
  char[] reihung;
  int    spitze;
  
  Zeichenstapel (int m) {
    maxLnge = m;
    reihung = new char[maxLnge];
    spitze = -1;
    } // Ende Konstruktor

  boolean istLeer()
    {return spitze == -1;}

  boolean istVoll()
    {return spitze == maxLnge - 1;}

  void legeAuf (char zeichen) {
    if (! istVoll())
      reihung[++spitze] = zeichen;
    } // Ende legeAuf

  char holeVon() {
    if (istLeer()) return '0';
    return reihung[spitze--];
    } // Ende holeVon

  char liesSpitze()
    {return reihung[spitze];}
 
  } // Ende Zeichenstapel

class Zahlstapel {
  // Implementation mittels Reihung

  int   maxLnge;
  int[] reihung;
  int   spitze;
  
  Zahlstapel (int m) {
    maxLnge = m;
    reihung = new int[maxLnge];
    spitze = -1;
    } // Ende Konstruktor

  boolean istLeer()
    {return spitze == -1;}

  boolean istVoll()
    {return spitze == maxLnge - 1;}

  void legeAuf (int zahl) {
    if (! istVoll())
      reihung[++spitze] = zahl;
    } // Ende legeAuf

  int holeVon() {
    if (istLeer()) return 0;
    return reihung[spitze--];
    } // Ende holeVon

  int liesSpitze()
    {return reihung[spitze];}
 
  } // Ende Zahlstapel
